// forkIt.cpp
#include <unistd.h> // sleep(), fork(), pid_t (in sys/types.h)
#include <iostream>
#include <string>

using namespace std;

// print message with current file, line, and function
#define PRINT_MSG(msg) cout << msg << " " << __FILE__ << " " << __LINE__ << " " << __FUNCTION__ << endl;

int main() {
  PRINT_MSG("Before fork");
  sleep(1);

  pid_t result = fork(); // child_result == 0, parent_result == PID of child

  PRINT_MSG("After fork");

  if (result == 0) {
    cout << "in child\n";
  } else {
    cout << "in parent\n";
  }

  sleep(1);

  if (result == 0) {
  PRINT_MSG("Child: After sleep");
  } else {
  PRINT_MSG("Parent: After sleep");
  }

  return 0;
}
